// Height of the cutter.
h = 20;
// Height of the thicker handle part.
b = 1;
// Width of the handle part.
w = 9;
// Scale factor for the outline.
s = 0.3;
// Cutter wall thickness.
e = 1;
// Inset of the inner detail.
i = 2;

module outline() {
	scale(s)
		import("reinhardt.dxf", layer="outline");
}

linear_extrude(height=h) {
	difference() {
		outline();
		offset(r=-e)
			outline();
	}
}

color("green")
linear_extrude(height=b) {
	difference() {
		offset(r=w/2)
			outline();
		offset(r=-w/2)
			outline();
	}
}

module inner() {
	scale(s)
		import("reinhardt.dxf", layer="inner");
}

linear_extrude(height=h-i) {
	difference() {
		inner();
		offset(r=-e)
			inner();
	}
}

color("green")
linear_extrude(height=b) {
	difference() {
		offset(r=w/2)
			inner();
		offset(r=-w/2)
		inner();
	}
}
