module sensemicro() {
  mw = 31;
  md = 18;
  mh = 1.5;

  // SenseBender Micro PCB
  color("green")
    cube([mw, md, mh]);

  sh = 4 - 1.5;
  sw = 11;
  sd = 16;

  // Serial header
  translate([0, md - sd, mh])
    cube([sw, sd, sh]);

  // Separation between boards.
  sep = 3;

  nw = 29;
  nd = 15.5;
  nh = 1.1;

  cw = 10;
  ch = 3;
  cd = 4;
  translate([1, 0.5, -(sep + nh)]) {
    // PCB
    color("green")
      cube([nw, nd, nh]);
    // Crystal
    translate([12, 0.5, -ch])
      color("silver")
      cube([cw, cd, ch]);

    // Header between boards.
    hw = 5;
    hd = 11;

    translate([nw - hw, nd - hd, nh])
      color("black")
      cube([hw, hd, sep]);
  }
}
